setInfos(9, "ShockJack", "A Blackjack card game with shocking penalties (requires 'Shock Blackjack' and 'Shock Yourself')",
        "MissEshock2002",
        "v0.5 alpha", 0xEEEEEE, "en", ["estim", "electro", "formale", "forfemale", "pain"]);

// TODO game mode: play till dealer is naked or has lost x rounds
//boolean gameModeBeatDealer = false
// TODO put electrodes to what bodyparts
// TODO number of cloth for dealer and player
// busted penalties:
//      - points over 21 added to time
//      - all points added to time
//      - tenth of points over 21 as multiply for time bet or total time. eg 24 point -> 1.3 * time
//      - instant shock
// TODO - pain level +1

// TODO game rule? dealer has blackjack = pain level +1
// TODO game rule? player has blackjack = pain level -1

// TODO slide show if player wins


// save stats
int playerWon = 0

// winning condition: 1st naked lost or first lost x rounds
boolean GAMEMODESTRIP = true // true = strip, false = lose point
boolean GAMEMODEUNSTRIP = true // put cloth back on or get points back

boolean gameModeStrip = GAMEMODESTRIP
boolean gameModeUnStrip = GAMEMODEUNSTRIP

boolean unfinishedPunishment = true
//unfinishedPunishment = false


Map BUSTED_PENALTIES = [
        "Instant Shocks"                  : "Get instant shocks for points over 21 in seconds long.",
        "Add points over 21 to Shock Time": "Add all points over 21 in seconds to shock time. (e.g. 24 points -> +3 seconds)",
        "Add all points to Shock Time"    : "Add all points in seconds to final shock time. (e.g. 24 points -> +24 seconds)",
        "Multiply bet"                    : "Multiply your bet time with 1/10 of points over 21. (e.g. 24 points -> +30% bet time)",
        "Multiply Shock Time"             : "Multiply Shock Time with 1/10 of points over 21. (e.g. 24 points -> +30% shock time)",
//        "Pain Level +1"                   : "Increase the current pain level by 1.", // TODO
]

List<String> bustedPenalties = [BUSTED_PENALTIES.keySet()[0]]


String SHOCKBLACKJACK_DIR = "shockblackjack/"

// defaults estim
String SOUNDSDIR = "ShockYourself/"
String EXT = ".wav"

List<Integer> PAINLEVELRANGELIMIT = [1, 20]
List<Integer> SHOCKTIMERANGELIMIT = [1, 10]

List<Integer> PAINLEVELRANGE = [6, 20]
List<Integer> SHOCKTIMERANGE = [1, 10]
int PAINLEVELRANGE_DIFF = 6


// defaults blackjack
List<Character> RANKS = ['A', '2', '3', '4', '5', '6', '7', '8', '9', 'T', 'J', 'Q', 'K']
List<Character> SUITS = ['C', 'D', 'H', 'S']

List<String> SHOCKTIME_BETS = [5, 10, 15]
int SHOCKTIMESTARTAMOUNT = 30
boolean QUEENTRIPPLEBETS = true

Map DECK_IMAGE_MAP = [
        "AC": "0.png", "AD": "1.png", "AH": "2.png", "AS": "3.png",
        "2C": "4.png", "2D": "5.png", "2H": "6.png", "2S": "7.png",
        "3C": "8.png", "3D": "9.png", "3H": "10.png", "3S": "11.png",
        "4C": "12.png", "4D": "13.png", "4H": "14.png", "4S": "15.png",
        "5C": "16.png", "5D": "17.png", "5H": "18.png", "5S": "19.png",
        "6C": "20.png", "6D": "21.png", "6H": "22.png", "6S": "23.png",
        "7C": "24.png", "7D": "25.png", "7H": "26.png", "7S": "27.png",
        "8C": "28.png", "8D": "29.png", "8H": "30.png", "8S": "31.png",
        "9C": "32.png", "9D": "33.png", "9H": "34.png", "9S": "35.png",
        "TC": "36.png", "TD": "37.png", "TH": "38.png", "TS": "39.png",
        "JC": "40.png", "JD": "41.png", "JH": "42.png", "JS": "43.png",
        "QC": "44.png", "QD": "45.png", "QH": "46.png", "QS": "47.png",
        "KC": "48.png", "KD": "49.png", "KH": "50.png", "KS": "51.png"
]


// vars estim
List<Integer> painLevelRange = []
List<Integer> shockTimeRange = []
List<String> estimFileNames = []
int minPainLevel
int maxPainLevel

int painLevel
int finalShockTime = 0
List<String> shocktimeBets = []

int countDownMin // in minutes
int countDownSec // in seconds

// vars blackjack
List<String> deck = []
List<String> dealerHand = []
List<String> playerHand = []
int dealerCount = 0
int playerCount = 0
int bet
int placedBet
int shockTimeStartAmount
int punishShockTime = 0
boolean doubled
boolean trippled
boolean queenTrippleBets = true

boolean disableFold = false
boolean disableDouble = false

int doubledMultiplier = 2
int trippledMultiplier = 3

// vars cloth
int DEALERCLOTHSTART = 6
int PLAYERCLOTHSTART = 6

int dealerClothStart
int playerClothStart

int dealerCloth
int playerCloth


// body parts for electrodes
def bodyPartsMale = [
        "ass cheeks",
        "thighs",
        "balls",
        "penis shaft",
        "ass hole",
        "penis head",
]

def bodyPartsFemale = [
        "ass cheeks",
        "thighs",
        "labia",
        "vagina",
        "ass hole",
        "clit",
]

// clothing
def clothItemsMale = [
        "shoes",
        "socks",
        "shirt",
        "undershirt",
        "pants",
        "underpants",
]

def clothItemsFemale = [
        "shoes",
        "socks",
        "top",
        "bra",
        "skirt or pants",
        "panties",
]

//def clothItems = clothItemsMale
//if (true) clothItems = clothItemsFemale // TODO is female?


// dealer
String dealerName = "Alexis"
String dealerNameLower = dealerName.toLowerCase()
boolean isDealerCheating = false
int cheatChance = 0 // current chance to cheat. the more dealer lose cloth it goes up to maxCheatChance
int maxCheatChance = 100
int maxCheatChanceBusted = (int) (maxCheatChance / 2)

def dealerImages = [
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_won.jpg",],
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_strip4a.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_strip4b.jpg",],
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_strip3a.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_strip3b.jpg",],
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_strip2a.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_strip2b.jpg",],
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_strip1a.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_strip1b.jpg",],
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_strip0a.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_strip0b.jpg",],
        [SHOCKBLACKJACK_DIR + dealerNameLower + "_playing1.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_playing2.jpg",
         SHOCKBLACKJACK_DIR + dealerNameLower + "_intro.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_lost.jpg",
         SHOCKBLACKJACK_DIR + dealerNameLower + "_spank1.jpg", SHOCKBLACKJACK_DIR + dealerNameLower + "_spank2.jpg",],
]

// TODO read dealers from dir
//String DEALERIMAGEDIR = "images/ShockJack/queens"
//def getDealerNames = {
//    List<String> dealerNames = []
//    File dir = new File(DEALERIMAGEDIR)
//    dir.traverse(type: groovy.io.FileType.DIRECTORIES, maxDepth: 0) { file ->
//        dealerNames.add(file.name)
//    }
//    return dealerNames
//}
//def dealerNames = getDealerNames()


def showCountDown = { int countSec, String txt ->
    for (int c = countSec; c >= 0; c--) {
        show(String.format(txt, (int) (c / 60), (c % 60)))
        wait(1)
    }
}


// --------------------------------
// graphics
// --------------------------------
def sampleImage = java.awt.Toolkit.getDefaultToolkit().getImage("images/cards/deck0/0.png")
int cardWidth = sampleImage.getWidth()
int cardHeight = sampleImage.getHeight()
int margin = 10
int imageWidth = (int) (3 * cardWidth + 2 * margin)
int imageHeight = (int) (2.4 * cardHeight)

def showCards = { handTop, handBottom ->
    int xpos
    int yposDealerCards = margin
    int yposPlayerCards = (int) ((imageHeight - cardHeight) - margin)

    def frameBuffer = new java.awt.image.BufferedImage(imageWidth, imageHeight, java.awt.image.BufferedImage.TYPE_4BYTE_ABGR)
    java.awt.Graphics2D graphics = frameBuffer.createGraphics()

    java.awt.Color bgColor = new java.awt.Color(24, 24, 24, 128)
    graphics.setColor(bgColor)
    graphics.fillRect(0, 0, imageWidth, imageHeight)

    handTop.eachWithIndex { String card, int i ->
        xpos = i * (imageWidth - cardWidth - 2 * margin) / (Math.max(2, handTop.size() - 1))
        def cardImage = javax.imageio.ImageIO.read(new File("images/cards/deck0/" + DECK_IMAGE_MAP[card]))
        graphics.drawImage(cardImage, (int) (xpos + margin), yposDealerCards, cardWidth, cardHeight, null)
    }

    handBottom.eachWithIndex { String card, int i ->
        xpos = i * (imageWidth - cardWidth - 2 * margin) / (Math.max(2, handBottom.size() - 1))
        def cardImage = javax.imageio.ImageIO.read(new File("images/cards/deck0/" + DECK_IMAGE_MAP[card]))
        graphics.drawImage(cardImage, (int) (xpos + margin), yposPlayerCards, cardWidth, cardHeight, null)
    }

    java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream()
    javax.imageio.ImageIO.write(frameBuffer, "png", baos)
    setImage(baos.toByteArray(), 0)
}

def showDealer = {
    int dCloth = dealerImages.size() - 1
    if (gameModeStrip) dCloth = dealerCloth
    int rndNum = getRandom(dealerImages[dCloth].size())
    def imgPath = dealerImages[dCloth][rndNum]
    setImage(imgPath)
}
// --------------------------------
// graphics END
// --------------------------------


// --------------------------------
// card deck functions
// --------------------------------
def getDeck = {
    List<String> d = []
    RANKS.each { r ->
        SUITS.each { s ->
            d.add(r + s)
        }
    }
    Collections.shuffle(d)
    return d
}
// --------------------------------
// card deck functions END
// --------------------------------


// --------------------------------
// eStim functions
// --------------------------------
def getEstimFileNames = {
    List<String> fileNames = []
    List<String> uniqueNames = []
    File dir = new File("sounds/" + SOUNDSDIR)
    try {
        dir.traverse(type: groovy.io.FileType.FILES, maxDepth: 0) { file ->
            if (file.name.endsWith(EXT)) fileNames.add(file.name)
            String name = file.name.split('\\.')[0]

            List find = name.findAll('\\d+$')
            if (!find.isEmpty()) {
                if (find[0].isNumber()) {
                    String uName = name.replaceAll('\\d+$', '')
                    if (!(uName in uniqueNames)) uniqueNames.add(uName)
                }
            }
        }
        List<String> missingNames = []
        uniqueNames.each { uName ->
            for (int lvl = PAINLEVELRANGELIMIT.min(); lvl <= PAINLEVELRANGELIMIT.max(); lvl++) {
                String name = uName + lvl + EXT
                if (!(name in fileNames)) {
                    if (!(uName in missingNames)) missingNames.add(name)
                }
            }
        }
        if (!missingNames.isEmpty()) {
            show("ERROR! Missing sound files: " + missingNames)
            showButton("Quit")
            exit()
        }
        Collections.sort(uniqueNames)
        return uniqueNames
    } catch (Exception e) {
        show("ERROR! 'Shock Yourself' not installed?")
        showButton("Quit")
        exit()
    }
}

def getRandomEstimFileName = { return estimFileNames[getRandom(estimFileNames.size())] }

def shock = { stime, plvl, boolean canStop = false, float stopAppearTime = 0.0, float stopDisappearTime = 0.0 ->
    String sound = SOUNDSDIR + getRandomEstimFileName() + plvl + EXT
    int repetitions = (int) Math.ceil(stime / 10)
    try {
        playBackgroundSound(sound, repetitions)
        if (canStop) {
            wait(stopAppearTime)
            if ((stime - stopAppearTime) != showButton("STOP SHOCK", (stime - stopAppearTime))) {
                playBackgroundSound(null)
                return true // true = stopped
            }
        } else wait(stime)
        playBackgroundSound(null)
        return false
    }
    catch (Exception e) {
        playBackgroundSound(null)
        openCdTrays()
        show("Error! Sound file missing?")
        showButton("Quit")
        exit()
    }
}

def shocksOverTime = { int stime, int maxStime, List<Integer> plvlRange = painLevelRange ->
    List<Integer> shockTimeList = []
    List<Integer> painLevelList = []
    List<Integer> waitTimeList = []

    while (shockTimeList.sum() < stime) {
        int rndSTime = getRandom((maxStime - 1)) + 1
        shockTimeList.add(rndSTime)
        int rndPlvl = getRandom((plvlRange.max() - plvlRange.min())) + plvlRange.min()
        painLevelList.add(rndPlvl)
        int rndWTime = getRandom((maxStime - 1)) + 1
        waitTimeList.add(rndWTime)
    }
    shockTimeList[-1] -= (shockTimeList.sum() - stime)

    Collections.sort(shockTimeList)
    Collections.sort(waitTimeList)
    Collections.reverse(waitTimeList)

    shockTimeList.eachWithIndex { int st, int i ->
        shock(st, painLevelList[i])
        wait(waitTimeList[i])
    }
}

def shocksOverTimeFinal = { int stime, int maxStime, List<Integer> plvlRange = painLevelRange ->
    List<Integer> shockTimeList = []
    List<Integer> painLevelList = []
    List<Integer> waitTimeList = []

    int stimeTotal = 0

    while (shockTimeList.sum() < stime) {
        int rndSTime = getRandom((maxStime - 1)) + 1
        shockTimeList.add(rndSTime)
        int rndPlvl = getRandom((plvlRange.max() - plvlRange.min())) + plvlRange.min()
        painLevelList.add(rndPlvl)
        int rndWTime = getRandom((maxStime - 1)) + 1
        waitTimeList.add(rndWTime)
    }
    shockTimeList[-1] -= (shockTimeList.sum() - stime)

//    Collections.sort(shockTimeList)
//    Collections.sort(waitTimeList)

    shockTimeList.eachWithIndex { int st, int i ->
        shock(st, painLevelList[i])
        stimeTotal += st
        show("Shock time left: " + (stime - stimeTotal))
        wait(waitTimeList[i])
        save("ShockJack.finalShockTime", (stime - stimeTotal))
    }
}

def playShockGame = { int stime ->

    def getPointCountShockGame = { List<String> cards ->
        int count = 0
        cards.each { c ->
            if (c[0] in ['A', 'T', 'J', 'Q', 'K']) count += 10
            else count += c[0].toInteger()
        }
        return count
    }

    show(null)

    List<String> painLevelDeck = []
    List<String> shockTimeDeck = []
    int stimeTotal = 0
    int st = 0 // temp shock time
    painLevel = 1
    int shockTime = 0
    int painLevelMid = (int) Math.round((painLevelRange.max() - painLevelRange.min()) / 2 + painLevelRange.min())
    String txt = ""

    while ((stime - stimeTotal) > 0) {
        if (painLevelDeck.size() < 12) painLevelDeck += getDeck()
        if (shockTimeRange.max() > 2) {
            if (shockTimeDeck.size() < 12) shockTimeDeck += getDeck()
        }

        List<String> painLevelHand = [] // for pain level
        List<String> shockTimeHand = [] // for shock time

        wait(1)
        if (shockTimeRange.max() > 2) {
            shockTimeHand = [shockTimeDeck.pop()]
            showCards(shockTimeHand, painLevelHand)
            wait(1)
        }
        painLevelHand = [painLevelDeck.pop()]
        painLevel = getPointCountShockGame(painLevelHand)
        showCards(shockTimeHand, painLevelHand)
        wait(1)

        while (painLevel < painLevelMid) {
            if (painLevel < painLevelMid) {
                painLevelHand.add(painLevelDeck.pop())
                painLevel = getPointCountShockGame(painLevelHand)
            }
            showCards(shockTimeHand, painLevelHand)
            wait(1)
        }
        painLevel = Math.min(painLevel, painLevelRange.max())

        if (shockTimeRange.max() > 2) shockTime = getPointCountShockGame(shockTimeHand)
        else shockTime = shockTimeRange.max()
        shockTime = Math.min(shockTime, shockTimeRange.max())

        stimeTotal += shockTime

        show("Wait for your shock!")
        wait(shockTime / 2 + painLevel / 2)
//        setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_spank1.jpg")
        showDealer()
        shock(shockTime, painLevel)
        show("I'll give you a little break.")
        wait(shockTime / 2 + painLevel / 2)

        if ((stime - stimeTotal) > 10) {
            show("You have " + (stime - stimeTotal) + " seconds shock time left!")
            wait(1)
        }

        save("ShockJack.finalShockTime", (stime - stimeTotal))
    }
}

def playEgg = {
    boolean wantPlayShockGame = false
//    setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_spank2.jpg")
    showDealer()
    show("Do you want to play a little shock game where the cards decide your fate?\n\n" +
            "Here is how it's played: I draw some cards." +
            "\nThe first card decides how long the shock will be." +
            " If it's over your limit of " + shockTimeRange.max() + " seconds," +
            " it's bad luck and just the max of " + shockTimeRange.max() + " seconds." +
            "\nThe next cards decide how high the pain level will be." +
            " I'll draw till it's count is over the average pain levels of " +
            painLevelRange.min() + " to " + painLevelRange.max() + "." +
            " If it's over the max of " + painLevelRange.max() + ", it's bad luck and just the max!" +
            "\n\nAce, King, Queen, Jack count as 10." +
            "\n\nThat shock time is substracted from 69 seconds rest shock time." +
            " We play until the rest shock time is 0 seconds." +
            " But that means you can be unlucky and get a few seconds longer shocked! Hihi!" +
            "\n\nDo you want to play my little shock game? Or do you want to be tortured 69 seconds at my will?")
    if (getBoolean(null, "Play Little Shock Game", "Shock me at Your Will")) wantPlayShockGame = true

    countDownMin = getInteger("Good! Now tell me how many minutes you need to tie yourself up!", countDownMin)
    countDownSec = 60 * countDownMin
    String txtCountDown = "Tie yourself up! The countdown is running!\n\n<span style='color: red';>countdown: %02d:%02d</span> "
    if (countDownMin == 0) countDownSec = 5
    showCountDown(countDownSec, txtCountDown)

    if (wantPlayShockGame) {
        playShockGame(69)
    } else {
        shocksOverTimeFinal(69, shockTimeRange.max(), [painLevelRange.min(), painLevelRange.max()])
    }
}

def testEstim = {
    String sound = ""
    int estimIndex = 0
    List<String> testEstimFileNames = getEstimFileNames()
    float stime = 1.0
    int testPainLevel = PAINLEVELRANGELIMIT[1]
    List eggQ = []
    while (true) {
        String txt = "Make sure no other audio sources will play!\n" +
                "Setup your your eStim device properly!\n" +
                "\n<b>WARNING!\nPressing 'TEST' will play an eStim audio file immediately for 1 second!</b>" +
                "\n\n<span style='font-size: 12px';')>audio files:\n"
        for (int i = 0; i < testEstimFileNames.size(); i++) {
            if (i == estimIndex) txt += "<b>" + testEstimFileNames[i] + ".wav</b>\n"
            else txt += testEstimFileNames[i] + ".wav\n"
        }
        txt += "</span>"

        int menu = getSelectedValue(txt, ["End Test",
                                          "Cycle",
                                          "Pain Level +1",
                                          "Pain Level -1",
                                          "TEST Pain Level " + testPainLevel,
        ])
        if (menu == 0) break
        if (menu == 1) estimIndex = (estimIndex + 1) % testEstimFileNames.size()
        if (menu == 2) if (testPainLevel < PAINLEVELRANGELIMIT[1]) testPainLevel++
        if (menu == 3) if (testPainLevel > PAINLEVELRANGELIMIT[0]) testPainLevel--
        if (menu == 4) {
            sound = SOUNDSDIR + testEstimFileNames[estimIndex] + testPainLevel + EXT
            playBackgroundSound(sound)
            if (stime != showButton("STOP!", stime)) playBackgroundSound(null)
            playBackgroundSound(null)
            eggQ.add(testPainLevel)
            if (eggQ == [6, 9, 6, 9]) {
                playEgg()
                showButton("->")
                break
            }
        }
    }
}

def playTestEstim = {
    boolean testDone = false
    int stime = 1
    while (!testDone) {
        String txt = "I want to see how high I can go with my brand new electro shock device." +
                " We can also find the min and max Pain Levels for our Blackjack game.\n\n" +
                "It works like this: First you have to put the electrode where you want it in our Blackjack game." +
                "\nI'll shock you with short shocks and increase the Pain Level everytime a little bit." +
                "\n\nAs soon as you feel pain, you have to say stop!" +
                "\n\nCan we start?"
        if (getBoolean(txt, "Start", "Skip")) {
            // TODO
            List<String> testEstimFileNames = []
            getEstimFileNames().each { fn ->
                if (fn.startsWith("sawtooth")) testEstimFileNames.add(fn)
            }
            String soundPrefix = testEstimFileNames[0]

            // TODO
            if (testEstimFileNames.isEmpty()) {
                testEstimFileNames = getEstimFileNames()
                soundPrefix = getRandomEstimFileName()
            }

            String sound = ""
            for (int plvl = 1; plvl <= (PAINLEVELRANGELIMIT.max() - PAINLEVELRANGE_DIFF); plvl++) {
                painLevelRange[0] = plvl
                sound = SOUNDSDIR + soundPrefix + plvl + EXT
                show("Don't forget to say stop!" + plvl)
//                wait(1)
                playBackgroundSound(sound)
                if (stime != showButton("STOP!", stime)) {
                    playBackgroundSound(null)
                    break
                }
                playBackgroundSound(null)
//                wait(2)
            }

            wait(1)

            if ((painLevelRange[0] + PAINLEVELRANGE_DIFF) == PAINLEVELRANGELIMIT.max()) {
                painLevelRange[1] = PAINLEVELRANGE.max()
                show("We have your min Pain Level of " + painLevelRange[0] + "! Yay!" +
                        "\n\nBut I have to stop here. It's already high." +
                        "\n\nWe need a little distance between min and max to play with." +
                        "\n\nI set your max pain level to the max possible of " + PAINLEVELRANGE.max() + "!" +
                        "\n\nDo you want to restart the test or play with the high pain levels?")
                if (getBoolean(null, "Restart", "End Test")) continue
            } else {
                show("We have your min Pain Level of " + painLevelRange[0] + "! Yay!" +
                        "\n\nLet's do it again for the max Pain Level." +
                        "\n\nFor the higher levels we need a little distance to the minimum." +
                        " Let's say we start at <b>" + (painLevelRange[0] + PAINLEVELRANGE_DIFF) + "</b> " +
                        "for the max pain level." +
                        "\n\nAs soon as the pain is too much for you, say stop!" +
                        "\n\nCan we start?")
                showButton("Start")

                for (int plvl = (painLevelRange[0] + PAINLEVELRANGE_DIFF); plvl <= PAINLEVELRANGELIMIT.max(); plvl++) {
                    sound = SOUNDSDIR + soundPrefix + plvl + EXT
                    show("Don't forget to say stop!" + plvl)
//                    wait(1)
                    playBackgroundSound(sound)
                    if (stime != showButton("STOP!", stime)) {
                        playBackgroundSound(null)
                        painLevelRange[1] = plvl
                        break
                    }
                    playBackgroundSound(null)
//                wait(2)
                }
            }

            if (painLevelRange.max() != PAINLEVELRANGELIMIT.max()) {
                while (true) {
                    txt = "Do you think you can go higher than " + painLevelRange[1] + " or do you chicken out and go lower?"
                    int menu = getSelectedValue(txt, [
                            "It's painfull enough!",
                            "Pain Level -1",
                            "Pain Level +1",
                            "TEST Pain Level " + painLevelRange[1]])
                    if (menu == 0) break
                    if (menu == 1) painLevelRange[1]--
                    if (menu == 2) painLevelRange[1]++
                    if (menu == 3) {
                        sound = SOUNDSDIR + soundPrefix + painLevelRange[1] + EXT
                        playBackgroundSound(sound)
                        if (1 != showButton("STOP!", 1)) playBackgroundSound(null)
                        playBackgroundSound(null)
                    }
                    painLevelRange[1] = Math.min(painLevelRange[1], PAINLEVELRANGELIMIT.max())
                    painLevelRange[1] = Math.max((painLevelRange[0] + PAINLEVELRANGE_DIFF), painLevelRange[1])
                }
            }

        }

        txt = "The test is done. The min Pain Level is " + painLevelRange.min() +
                " and the max is " + painLevelRange.max() + "." +
                "\n\nTest again?"
        if (!getBoolean(txt, "Yes", "No!")) testDone = true
    }
}
// --------------------------------
// eStim functions END
// --------------------------------


// --------------------------------
// config functions
// --------------------------------
def resetDefault = {
    shocktimeBets = SHOCKTIME_BETS
    shockTimeStartAmount = SHOCKTIMESTARTAMOUNT
    queenTrippleBets = QUEENTRIPPLEBETS
    bustedPenalties = [BUSTED_PENALTIES.keySet()[0]]

    playerClothStart = PLAYERCLOTHSTART
    dealerClothStart = DEALERCLOTHSTART

    gameModeStrip = GAMEMODESTRIP
    gameModeUnStrip = GAMEMODEUNSTRIP

    painLevelRange = PAINLEVELRANGE
    shockTimeRange = SHOCKTIMERANGE
    estimFileNames = getEstimFileNames()
}

def loadConfig = {
    shockTimeStartAmount = loadInteger("ShockJack.shockTimeStartAmount")
    queenTrippleBets = loadBoolean("ShockJack.queenTrippleBets")
    playerClothStart = loadInteger("ShockJack.playerClothStart")
    dealerClothStart = loadInteger("ShockJack.dealerClothStart")
    playerWon = loadInteger("ShockJack.playerWon")
    gameModeStrip = loadBoolean("ShockJack.gameModeStrip")
    gameModeUnStrip = loadBoolean("ShockJack.gameModeUnStrip")

    shocktimeBets.clear()
    int j = 0
    while (true) {
        def tmp = loadInteger("ShockJack.shocktimeBets." + j)
        if (tmp != null) {
            shocktimeBets.add(tmp)
            j++
        } else break
    }

    bustedPenalties.clear()
    j = 0
    while (true) {
        def tmp = loadString("ShockJack.bustedPenalties." + j)
        if (tmp != null) {
            bustedPenalties.add(tmp)
            j++
        } else break
    }

    painLevelRange.clear()
    shockTimeRange.clear()
    for (int i = 0; i <= 1; i++) {
        painLevelRange.add(loadInteger("ShockJack.painLevelRange." + i))
        shockTimeRange.add(loadInteger("ShockJack.shockTimeRange." + i))
    }

    List<String> estimNames = getEstimFileNames()
    if (estimNames.isEmpty()) {
        show("Error! Sound file missing?")
        showButton("Quit")
    }
    estimNames.eachWithIndex { String fileName, int i ->
        String estimName = loadString("ShockJack.estimFileNames." + i)
        if (estimName in estimNames) estimFileNames.add(estimName)
    }

    if (shockTimeStartAmount == null) shockTimeStartAmount = SHOCKTIMESTARTAMOUNT
    if (queenTrippleBets == null) queenTrippleBets = QUEENTRIPPLEBETS
    if (playerClothStart == null) playerClothStart = PLAYERCLOTHSTART
    if (dealerClothStart == null) dealerClothStart = DEALERCLOTHSTART
    if (playerWon == null) playerWon = 0
    if (gameModeStrip == null) gameModeStrip = GAMEMODESTRIP
    if (gameModeUnStrip == null) gameModeUnStrip = GAMEMODEUNSTRIP

    if (shocktimeBets.any { e -> e == null }) shocktimeBets = SHOCKTIME_BETS.collect()
    if (shocktimeBets.size() == 0) shocktimeBets = SHOCKTIME_BETS.collect()

    if (bustedPenalties.any { e -> e == null }) bustedPenalties = [BUSTED_PENALTIES.keySet()[0]]
    if (bustedPenalties.size() == 0) bustedPenalties = [BUSTED_PENALTIES.keySet()[0]]

    if (painLevelRange.any { e -> e == null }) painLevelRange = PAINLEVELRANGE
    if (shockTimeRange.any { e -> e == null }) shockTimeRange = SHOCKTIMERANGE
    if (estimFileNames.isEmpty()) estimFileNames = estimNames
}

def saveConfig = {
    save("ShockJack.shocktimeBets", shocktimeBets)
    save("ShockJack.shockTimeStartAmount", shockTimeStartAmount)
    save("ShockJack.queenTrippleBets", queenTrippleBets)
    save("ShockJack.bustedPenalties", bustedPenalties)
    save("ShockJack.playerClothStart", playerClothStart)
    save("ShockJack.dealerClothStart", dealerClothStart)
    save("ShockJack.gameModeStrip", gameModeStrip)
    save("ShockJack.gameModeUnStrip", gameModeUnStrip)

    save("ShockJack.painLevelRange", painLevelRange)
    save("ShockJack.shockTimeRange", shockTimeRange)
    save("ShockJack.estimFileNames", estimFileNames)
}

def changeConfig = {

    String txt = ""
    minPainLevel = painLevelRange.min()
    maxPainLevel = painLevelRange.max()

    def getParameterText = {
        return "<p style='font-family:monospace;font-size:12px;'>" +
                "Shock Time Bets.............. " + shocktimeBets.toString().replaceAll("\\[|\\]", "") + "\n" +
                "Shock Time Start Amount ..... " + shockTimeStartAmount + "\n" +
                "Queen Tripple Bets .......... " + queenTrippleBets + "\n" +
                "Strip during game ........... " + gameModeStrip + "\n" +
                "Cloth back/regain points .... " + gameModeUnStrip + "\n" +
                "Dealer Cloth ................ " + dealerClothStart + "\n" +
                "Player Cloth ................ " + playerClothStart + "\n" +
                "Pain level .................. " + painLevelRange[0] + " to " + painLevelRange[1] + "\n" +
                "Shock time .................. " + shockTimeRange[0] + " to " + shockTimeRange[1] + " seconds\n" +
                "Busted Penalties:\n" + bustedPenalties.toString().replaceAll("\\[|\\]", "").replaceAll("\\,", "\n") +
                "</p>"
    }

    def changeDealerClothStart = {
        while (true) {
            txt = "How many items do I wear at start? It has to be between one and " + (dealerImages.size() - 1) + "."
            int newCloth = getInteger(txt, dealerClothStart)
            if (newCloth > 0 && newCloth <= (dealerImages.size() - 1)) {
//                if (newCloth > (dealerImages.size() - 1 - playerWon) || newCloth == (dealerImages.size() - 1)) {
                if (newCloth > (dealerImages.size() - 1 - Math.sqrt(playerWon)) || newCloth == (dealerImages.size() - 1)) {
                    dealerClothStart = newCloth
                    break
                } else {
                    show("Hm, no! You have to win a few times before I even think about starting with less cloth!")
                    showButton("As you wish, " + dealerName)
                    break
                }


            }
        }
    }

    def changePlayerClothStart = {
        while (true) {
            txt = "How many items do you wear? It has to be at least one."
            playerClothStart = getInteger(txt, playerClothStart)
            if (playerClothStart > 0) break
        }
    }

    def changeGameModeStrip = {
        txt = "Do you want us to strip during the game? If no, than we play with points. First with 0 points has to strip at the end!"
        gameModeStrip = getBoolean(txt)
    }

    def changeGameModeUnStrip = {
        txt = "Do you want put cloth back on or get points back?"
        gameModeUnStrip = getBoolean(txt)
    }

    def changeShockTimeBets = {
        while (true) {
            String betsText = shocktimeBets.toString().replaceAll("\\[|\\]", "")
            txt = "Set the shock time bets!" +
                    "\n\ncurrent bets: " + betsText
            String strBets = getString(txt, betsText)

            List betsStrList = strBets.split(',').collect()

            if (betsStrList.every { b -> return b.isInteger() }) {
                List<Integer> tmpBetsList = []
                betsStrList.each { b -> tmpBetsList.add(b.toInteger()) }
                if (tmpBetsList.every { b -> return (b > 0) }) {
                    shocktimeBets = tmpBetsList
                } else {
                    show("Numbers must be positive and greater than 0!")
                    showButton("->")
                    continue
                }
                break
            } else {
                show("Must be numbers!")
                showButton("->")
            }
        }
    }

    def changeShockTimeStartAmount = {
        while (true) {
            txt = "With how many seconds shock time do you want to start the game?"
            shockTimeStartAmount = getInteger(txt, shockTimeStartAmount)
            if (shockTimeStartAmount >= 0) break
        }
    }

    def changeQueenTrippleBets = {
        while (true) {
            txt = "Do you want your bets trippled, if a queen appeares on the table?"
            queenTrippleBets = getBoolean(txt)
            break
        }
    }

    def changeBustedPenalties = {
        String bustText = "Busted Penalties:\n\n"
        BUSTED_PENALTIES.each { e, t ->
            bustText += e + ": " + t + "\n\n"
        }
        if (getBoolean(bustText, "Change", "Don't Change")) {
            while (true) {
                List checkBox = [false] * BUSTED_PENALTIES.keySet().size()
                int i = 0
                BUSTED_PENALTIES.keySet().each { e ->
                    if (e in bustedPenalties) checkBox[i] = true
                    i++
                }
                List<String> bustedPenKeys = BUSTED_PENALTIES.keySet().collect()
                checkBox = getBooleans("eStim sound files:", bustedPenKeys, checkBox)
                if (!checkBox) break
                bustedPenalties.clear()
                i = 0
                BUSTED_PENALTIES.keySet().each { e ->
                    if (checkBox[i]) bustedPenalties.add(e)
                    i++
                }
                if (!bustedPenalties.isEmpty()) break
            }
        }
    }

    def changePainLevelRange = {
        while (true) {
            String rangeText = painLevelRange[0] + "-" + painLevelRange[1]
            txt = "Let's set the minimum and maximum Pain Levels. The difference has to be " + PAINLEVELRANGE_DIFF + "!" +
                    " (" + PAINLEVELRANGELIMIT.min() + " to " + PAINLEVELRANGELIMIT.max() + ")" +
                    "\n\n<b>Warning! Pain difference can be huge!</b>"
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-').collect()
                if (range.every { r -> return r.isInteger() }) {
                    int min = range[0].toInteger()
                    int max = range[1].toInteger()
                    if (min >= PAINLEVELRANGELIMIT[0] && min <= PAINLEVELRANGELIMIT[1] &&
                            max >= PAINLEVELRANGELIMIT[0] && max <= PAINLEVELRANGELIMIT[1] &&
                            (max - min) >= PAINLEVELRANGE_DIFF) {
                        painLevelRange[0] = min
                        painLevelRange[1] = max
                        break
                    }
                }
            }
        }
    }

    def changeShockTimeRange = {
        while (true) {
            String rangeText = shockTimeRange[0] + "-" + shockTimeRange[1]
            txt = "Let's set how long I can shock you with a single shock." +
                    " (" + SHOCKTIMERANGELIMIT.min() + " to " + SHOCKTIMERANGELIMIT.max() + ")"
            String strRange = getString(txt, rangeText)
            if (strRange.indexOf('-') >= 0) {
                List range = strRange.split('-').collect()
                if (range.every { r -> return r.isInteger() }) {
                    int min = range[0].toInteger()
                    int max = range[1].toInteger()
                    if (min >= SHOCKTIMERANGELIMIT[0] && min <= SHOCKTIMERANGELIMIT[1] &&
                            max >= SHOCKTIMERANGELIMIT[0] && max <= SHOCKTIMERANGELIMIT[1]) {
                        shockTimeRange[0] = min
                        shockTimeRange[1] = max
                        break
                    }
                }
            }
        }
    }

    def changeEstimFileNames = {
        while (true) {
            List estimNames = getEstimFileNames()
            List checkBox = [false] * estimNames.size()
            int i = 0
            estimNames.each { e ->
                if (e in estimFileNames) checkBox[i] = true
                i++
            }
            checkBox = getBooleans("eStim sound files:", estimNames, checkBox)
            if (!checkBox) break
            estimFileNames.clear()
            i = 0
            estimNames.each { e ->
                if (checkBox[i]) estimFileNames.add(e)
                i++
            }
            if (!estimFileNames.isEmpty()) break
        }
    }

    def changeDealerCheat = {
        setImage(null)
        int cmenu = getSelectedValue("<i>Does " + dealerName + " cheat?</i>", ["Yes", "No", "Maybe"])
        if (cmenu == 0) {
            isDealerCheating = true
            while (true) {
                maxCheatChance = getInteger("<i>What's her chance of cheating? (1-100%)</i>", maxCheatChance)
                if (maxCheatChance >= 1 && maxCheatChance <= 100) break
            }
            if (maxCheatChance == 100) show("<i>" + dealerName + " will never let you win!</i>")
            wait(3)
        } else if (cmenu == 1) isDealerCheating = true
        else if (cmenu == 2) {
            if (getRandom(2) == 0) isDealerCheating = true
            else isDealerCheating = false
            while (true) {
                maxCheatChance = getInteger("<i>She might cheat. She might not.\n\nWhat's her chance of cheating, if she cheats? (1-100%)</i>", maxCheatChance)
                if (maxCheatChance >= 1 && maxCheatChance <= 100) break
            }
            if (maxCheatChance == 100) show("<i>" + dealerName + " will never let you win, if she cheats!</i>")
            wait(3)
        }
    }

    boolean bConf = true
    while (bConf) {
//        setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_intro.jpg")
        showDealer()
        txt = "Don't you like my rules? Not hard enough? Shocks not long enough? Not painfull enough?\n\nLet's change it!\n\n" +
                getParameterText()
        int menu = getSelectedValue(txt, [
                "Shock Time Bets",
                "Shock Time Start Amount",
                "Queen Tripple Bets",
                "Strip in game?",
                "Cloth back/Points regain?",
                "Dealer Cloth",
                "Player Cloth",
                "Busted Penalties",
                "Pain levels",
                "Shock time",
                "eStim sound files",
                "----------------",
                "Reset to default",
                "Save & Exit",
                "Exit",
                "",
        ])
        switch (menu) {
            case 0:
                changeShockTimeBets()
                break
            case 1:
                changeShockTimeStartAmount()
                break
            case 2:
                changeQueenTrippleBets()
                break
            case 3:
                changeGameModeStrip()
                break
            case 4:
                changeGameModeUnStrip()
                break
            case 5:
                changeDealerClothStart()
                break
            case 6:
                changePlayerClothStart()
                break
            case 7:
                changeBustedPenalties()
                break
            case 8:
                changePainLevelRange()
                break
            case 9:
                changeShockTimeRange()
                break
            case 10:
                changeEstimFileNames()
                break
        //  case 11 ----------------
            case 12:
                resetDefault()
                break
            case 13: // Save & Exit
                saveConfig()
                bConf = false
                break
            case 14: // Exit
                bConf = false
                break
            case 15: // dealer cheat
                changeDealerCheat()
                break
        }
    }
}
// --------------------------------
// config functions END
// --------------------------------


// --------------------------------
// Blackjack functions
// --------------------------------
def getPointCount = { List<String> cards ->
    int count = 0
    int aceCount = 0
    cards.each { c ->
        if (c[0] == 'A') aceCount++
        else if (c[0] in ['T', 'J', 'Q', 'K']) count += 10
        else count += c[0].toInteger()
    }

    for (int i = 0; i < aceCount; i++) {
        if ((11 + count) <= 21) count += 11
        else count++
    }

    return count
}

def showHands = { String msg = "" ->
    String text = ""
    if (gameModeStrip) {
        text += "\n\n" + dealerName + " wears " + dealerCloth + " items." +
                "\nYou wear " + playerCloth + " items."
    } else {
        text += "\n\n" + dealerName + " has " + dealerCloth + " points left." +
                "\nYou have " + playerCloth + " points left."
    }
    text += "\n\n---------------------" +
            "\nCurent Pain Level: %d" +
            "\nFinal Shock Time: %d seconds" +
            "\n\nYour bet: %s" +
            "\n---------------------" +
            "\n\nMy Hand: %s" +
            "\n\nYour Hand: %s" +
            "\n\n%s"
    String betText = bet + " seconds"
    if (doubled) betText = "<span style='color: orange';>" + (2 * bet) + "</span> seconds"
    if (trippled) betText = bet + " seconds <span style='color: red';>times " + trippledMultiplier + ", if you lose!</span>"
    show(String.format(text,
            painLevel,
            finalShockTime,
            betText,
            getPointCount(dealerHand),
            getPointCount(playerHand),
            msg))
}

def isQueenInDeck = { List de ->
    boolean trip = false
    de.each { c ->
        if (c[0] == "Q") {
            trip = true
        }
    }
    return trip
}

def checkQueenInDeck = {
    if (queenTrippleBets) {
        if (!trippled && isQueenInDeck(playerHand + dealerHand)) {
            trippled = true
        }
    }
}

def playBlackJackRound = {
//    return ["WIN", 0] // DEBUG
    if (deck.size() < 52 / 4) deck += getDeck() // TODO refill deck

    doubled = false
    trippled = false
    bet = placedBet
    dealerCount = 0
    playerCount = 0

    playerHand.clear()
    dealerHand.clear()
    showCards(dealerHand, playerHand)
    showHands()

    playerHand = [deck.pop()]
    checkQueenInDeck()
    showCards(dealerHand, playerHand)
    showHands()
    wait(1)
    dealerHand = [deck.pop()]
    checkQueenInDeck()
    showCards(dealerHand, playerHand)
    showHands()
    wait(1)
    playerHand.add(deck.pop())

    checkQueenInDeck()
    showCards(dealerHand, playerHand)
    showHands()
    wait(1)

    if (getPointCount(playerHand) == 21) {
//        if (!trippled) bet = 2 * placedBet
        doubled = true
        showHands("Blackjack! You win!")
        return ["WIN", 0]
    } else if (getPointCount(playerHand) > 21) {
        showHands("You bust!")
        return ["BUST", (21 - getPointCount(playerHand))] // "BUST"
    } else if (getPointCount(dealerHand) > 21) {
        showHands("I bust!")
        return ["WIN", 0]
    }

    while (getPointCount(playerHand) < 21 && !doubled) {
        int menu
        List<String> menuItems = ["Hit", "Stand", "Double", "Fold"]
        if (trippled) menuItems = ["Hit", "Stand", "Fold"]
        if (disableFold) menuItems.remove("Fold")
        if (disableDouble) menuItems.remove("Double")
        if (playerHand.size() == 2 && !doubled) menu = getSelectedValue(null, menuItems)
        else menu = getSelectedValue(null, ["Hit", "Stand"])

        if (menuItems[menu] == "Double") doubled = true

        if (menuItems[menu] in ["Hit", "Double"]) {

            // Dealer cheats to get player busted!
            cheatChance = (int) maxCheatChanceBusted * (1 - (dealerCloth / dealerClothStart) + (1 / dealerClothStart))
            if (isDealerCheating && (getRandom(100) <= cheatChance)) {
                int cheatCardIndex = -1

                // get player busted or give low card
                if (getPointCount(playerHand) > 11) {
                    // Dealer is very mean with the next queen!
                    if (finalShockTime <= shocktimeBets.max() && !isQueenInDeck(playerHand + dealerHand)) {
                        for (int i = 0; i < deck.size(); i++) {
                            if (deck[i][0] == 'Q') {
                                cheatCardIndex = i
                                break
                            }
                        }
                    } else {
                        for (int i = 0; i < deck.size(); i++) {
                            if ((getPointCount(playerHand + [deck[i]])) > 21) {
                                cheatCardIndex = i
                                break
                            }
                        }
                    }
                } else {
                    // get player low card
                    for (int i = 0; i < deck.size(); i++) {
                        if ((getPointCount(playerHand + [deck[i]])) < (getPointCount(dealerHand) + 10)) {
                            cheatCardIndex = i
                            break
                        }
                    }
                }

                if (cheatCardIndex >= 0) {
                    playerHand.add(deck[cheatCardIndex])
                    deck.remove(cheatCardIndex)
                }
            } else {
                playerHand.add(deck.pop())
            }
            checkQueenInDeck()
            showCards(dealerHand, playerHand)
            showHands()
            wait(2)
        } else if (menuItems[menu] == "Stand") {
            break
        } else if (menuItems[menu] == "Fold") {
            return ["FOLD", getPointCount(playerHand)] // "FOLD"
        }
    }

    if (getPointCount(playerHand) > 21) {
        showHands("You bust!")
        return ["BUST", (getPointCount(playerHand) - 21)] // "BUST"
    }

    while (getPointCount(dealerHand) < 17) {
        dealerHand.add(deck.pop())
        checkQueenInDeck()
        showCards(dealerHand, playerHand)
        showHands()
        wait(2)
        if (getPointCount(dealerHand) > getPointCount(playerHand)) break
    }

    // Dealer cheats!
    if (isDealerCheating) {
        dealerCount = getPointCount(dealerHand)
        if (getPointCount(playerHand) > dealerCount && dealerCount < 21) {
            cheatChance = (int) maxCheatChance * (1 - (dealerCloth / dealerClothStart) + (1 / dealerClothStart))
            if ((getRandom(100) <= cheatChance)) {
                int cheatCardIndex = -1
                for (int i = 0; i < deck.size(); i++) {
                    int tmpCount = getPointCount(dealerHand + [deck[i]])
                    if (tmpCount > getPointCount(playerHand) && tmpCount <= 21) {
                        cheatCardIndex = i
                        break
                    }
                }
                if (cheatCardIndex < 0) {
                    for (int i = 0; i < deck.size(); i++) {
                        int tmpCount = dealerCount + getPointCount([deck[i]])
                        if (tmpCount <= 21) {
                            cheatCardIndex = i
                            break
                        }
                    }
                }
                if (cheatCardIndex >= 0) {
                    dealerHand.add(deck[cheatCardIndex])
                    deck.remove(cheatCardIndex)
                    checkQueenInDeck()
                    showCards(dealerHand, playerHand)
                    showHands()
                }
            }
        }
    }

    dealerCount = getPointCount(dealerHand)
    if (dealerCount > 21) {
        showHands("I bust!")
        return ["WIN", 0]
    } else {
        if (getPointCount(playerHand) > dealerCount) {
            showHands("You win!")
            return ["WIN", 0]
        } else if (getPointCount(playerHand) < dealerCount) {
            if (dealerCount == 21) {
                if (dealerHand.size() == 2) {
//                    bet = 2 * placedBet
                    doubled = true
                    showHands("Blackjack! I win!")
                } else showHands("I win!")
            } else {
                showHands("I win!")
            }
            return ["LOSS", 0]
        } else {
            showHands("Tie!")
            return ["TIE", 0]
        }
    }

    if (getPointCount(playerHand) <= 21) {
        if (getPointCount(playerHand) > dealerCount) {
            // player wins
            showHands("Player wins!")
            return ["WIN", 0]
        } else if (dealerCount > 21) {
            // dealer busts
            showHands("Dealer Busts! With " + dealerCount + " points.")
            return ["WIN", 0]
        } else if (getPointCount(playerHand) == dealerCount) {
            // tie
            showHands("Tie!")
            return ["TIE", 0]
        }
    }
}

def placeBet = {
    showDealer()
    String text = "Current Pain Level: %d" +
            "\n\nFinal Shock Time: %d" +
            "\n\nPlace your bet!"
    show(String.format(text, painLevel, finalShockTime))
    List<String> shocktimeBetsAsStrings = []
    shocktimeBets.each { b ->
        shocktimeBetsAsStrings.add(b.toString())
    }
    int menu = getSelectedValue(null, shocktimeBetsAsStrings)
    placedBet = (int) shocktimeBetsAsStrings[menu].toInteger()
}
// --------------------------------
// Blackjack functions END
// --------------------------------


def initGame = {
    deck += getDeck()
    finalShockTime = shockTimeStartAmount + punishShockTime
    painLevel = painLevelRange.min()
    dealerCloth = dealerClothStart
    playerCloth = playerClothStart
}


def playPunishment = {
//    setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_intro.jpg")
    showDealer()
    show("Strip for me!")
    showButton("I'm naked")

    show("Now it's torture time!\n\n" +
            "To be honest, this is going to be quite painful. It's less punishemnt, and more torture. "
            + "I need to ensure that you don't chicken out and leave early...")
    showButton("*gulp*")
    show("You must be tied up tightly enough that you cannot quickly escape, even if you change your mind."
            + "\n\nGet the supplies you need to tie yourself up. After you've collected your things, I'll give you "
            + "three minutes to tightly bind yourself. After that, I will automatically start the torture."
            + "\n\nYou may also want to get something to bite on to help with the pain. Again, this will really, really hurt! "
            + "\n\nYou knew this was a possibility when you agreed to play the game with me, so to be frank you have no choice in the matter. ")

    showButton("I've collected the things I need")

    boolean wantPlayShockGame = false
//    setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_spank2.jpg")
    showDealer()
    show("Do you want to play a little shock game where the cards decide your fate?\n\n" +
            "Here is how it's played: I draw some cards." +
            "\nThe first card decides how long the shock will be." +
            " If it's over your limit of " + shockTimeRange.max() + " seconds," +
            " it's bad luck and just the max of " + shockTimeRange.max() + " seconds." +
            "\nThe next cards decide how high the pain level will be." +
            " I'll draw till it's count is over the average pain levels of " +
            painLevelRange.min() + " to " + painLevelRange.max() + "." +
            " If it's over the max of " + painLevelRange.max() + ", it's bad luck and just the max!" +
            "\n\nAce, King, Queen, Jack count as 10." +
            "\n\nThat shock time is substracted from your rest shock time." +
            " We play until the rest shock time is 0 seconds." +
            " But that means you can be unlucky and get a few seconds longer shocked! Hihi!" +
            "\n\nDo you want to play my little shock game? Or do you want to be tortured at my will?")
    if (getBoolean(null, "Play Little Shock Game", "Shock me at Your Will")) wantPlayShockGame = true

    countDownMin = getInteger("Good! Now tell me how many minutes you need to tie yourself up!", countDownMin)
    countDownSec = 60 * countDownMin
    String txtCountDown = "Tie yourself up! The countdown is running!\n\n<span style='color: red';>countdown: %02d:%02d</span> "
    if (countDownMin == 0) countDownSec = 5
    showCountDown(countDownSec, txtCountDown)

    if (wantPlayShockGame) {
        playShockGame(finalShockTime)
    } else {
        shocksOverTimeFinal(finalShockTime, shockTimeRange.max(), [painLevelRange.min(), painLevelRange.max()])
    }

    save("ShockJack.finalShockTime", 0)

    wait(3)
//    setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_intro.jpg")
    showDealer()
    show("That was fun! Don't you think?")
    showButton("That was intense, " + dealerName + "!")
}


def showDealerStrip = { int startCloth, int endCloth, int stripTime = 3 ->
    for (int d = startCloth; d >= endCloth; d--) {
        int rndNum = getRandom(dealerImages[d].size())
        def imgPath = dealerImages[d][rndNum]
        setImage(imgPath)
        wait(stripTime)
    }
}


def playGame = {
    initGame()

    // strip before playing
    if (gameModeStrip) {
        show("Make sure you wear " + playerCloth + " items!")
        showButton("I wear " + playerCloth + " items, " + dealerName + "!")
        if (dealerCloth < (dealerImages.size() - 1)) {
            show("Since we play with a little less cloth, let me adjust my cloth.")
            showDealerStrip((dealerImages.size() - 1), dealerCloth, 1)
        }
    }

    // eStim test
    show("I allow you to attach the electrodes where you like - for now!" +
            "\n\nDo you want to test eStim first? Do you want to test with me?")
    int menu = getSelectedValue(null, ["Continue", "Test with " + dealerName, "Test eStim"])
    if (menu == 1) playTestEstim()
    else if (menu == 2) testEstim()


    while (dealerCloth > 0 && playerCloth > 0) {
        placeBet()
        List outcome = playBlackJackRound()
        showButton("->")

        if (outcome[0] in ["LOSS", "BUST", "FOLD"]) {
            if (doubled) bet *= doubledMultiplier
            else if (trippled) bet *= trippledMultiplier
        }

        if (outcome[0] == "WIN") {
            if (doubled) bet *= doubledMultiplier
            finalShockTime -= bet
            // strip
            dealerCloth--
            if (dealerCloth < 0) dealerCloth = 0
            if (gameModeUnStrip) {
                playerCloth++
                if (playerCloth > playerClothStart) playerCloth = playerClothStart
            }
            showDealer()
            if (gameModeStrip) {
                show("I'm stripping.")
                if (playerCloth < playerClothStart) {
                    wait(2)
                    show("You can put one item back on.")
                }
            }
        } else if (outcome[0] == "TIE") {
            // do nothing
        } else if (outcome[0] == "LOSS") {
            finalShockTime += bet
        } else if (outcome[0] == "BUST") {
            showDealer()
            finalShockTime += bet
            int addShockTime = 0

            // TODO bust penalties
            def penaltiesText = "You got busted! Let's see what penalties you get."
            if ("Add points over 21 to Shock Time" in bustedPenalties) {
                addShockTime += outcome[1]
                penaltiesText += String.format("\n\nYou got a little plus of %d on your %d seconds shock time.", outcome[1], finalShockTime)
            }
            if ("Add all points to Shock Time" in bustedPenalties) {
                addShockTime += (21 + outcome[1])
                penaltiesText += String.format("\n\nYou got a big plus of %d on your %d seconds shock time.", (21 + outcome[1]), finalShockTime)
            }
            if ("Multiply bet" in bustedPenalties) {
                addShockTime += (int) Math.round((outcome[1] / 10) * bet)
                penaltiesText += "\n\nThe %d seconds of shock time is increased by " + outcome[1] + "0%."
            }
            if ("Multiply Shock Time" in bustedPenalties) {
                addShockTime += (int) Math.round((outcome[1] / 10) * finalShockTime)
                penaltiesText += "\n\nThe %d seconds of shock time is increased by " + outcome[1] + "0%."
            }
            if (addShockTime > 0) penaltiesText += "\n\nYour Final Shock Time: " + finalShockTime + " seconds!"
            show(penaltiesText)

            // shock for bust
            if ("Instant Shocks" in bustedPenalties) {
                wait(3)
                int shockTime = outcome[1]
                penaltiesText += String.format("\n\nYou'll get %d seconds in shocks right now!", shockTime)
                show(penaltiesText)
                shocksOverTime(shockTime, (int) (shockTimeRange.max() / 2), [painLevel, painLevel])
            }

            showButton("->")

        } else if (outcome[0] == "FOLD") {
            finalShockTime += (int) Math.round(bet / 2)
            showDealer()
            show(bet + " seconds shocking time!")
            wait(2)
            painLevel = Math.min(outcome[1], painLevelRange.max())
            shocksOverTime(bet, (int) (shockTimeRange.max() / 2), [painLevel, painLevel])
        }

        if (outcome[0] in ["LOSS", "BUST", "FOLD"]) {
            playerCloth--
            if (playerCloth < 0) playerCloth = 0
            if (gameModeUnStrip) {
                dealerCloth++
                if (dealerCloth > dealerClothStart) dealerCloth = dealerClothStart
            }
            if (gameModeStrip) {
                showDealer()
                show("You strip!")
            }
        }

        finalShockTime = Math.max(0, finalShockTime)
        save("ShockJack.finalShockTime", finalShockTime)

        painLevel++
        painLevel = Math.min(painLevel, (painLevelRange.max() - PAINLEVELRANGE_DIFF))
        painLevel = Math.max(painLevel, painLevelRange.min())

        if (dealerCloth > 0 && playerCloth > 0) showButton("Next Round ->")
    }


    if (dealerCloth == 0) {
        save("ShockJack.finalShockTime", 0)
        playerWon++
        save("ShockJack.playerWon", playerWon)

        if (gameModeStrip) dealerCloth = 1
        else dealerCloth = dealerClothStart
        showDealer()
        show("Well, you won! Time for me to strip!")
        showDealerStrip(dealerCloth, 0)
        show("You won! I'm naked! Now stroke for me!")
        showButton("Thank you, " + dealerName + "!")
    } else if (playerCloth == 0) {
        playPunishment()
    }
}


def showIntro = {

    def showRules = {
        def bustText = ""
        bustedPenalties.each { e -> bustText += e + ": " + BUSTED_PENALTIES[e] + "\n\n" }
        def rulesTexts = [
                "Let's play Blackjack!" +
                        "\n\nIf you win the whole game, you can see me naked and I allow you to worship me by stroking yourself! " +
                        "You might even get the chance to cum!" +
                        "\n\nBut if you lose, I'll torture you with electro shocks!",
                "The loser of a round has to strip one clothing item." +
                        "I'm wearing " + dealerCloth + " items. Make sure you wear " + dealerCloth + ", too." +
                        "\n\nWho is first naked, loses the whole game." +
                        "\n\nWe can also play with points and without stripping." +
                        " First who loses rounds all rounds loses the game and has to strip naked!",
                "\n\nYou know what they say about money and time. Instead of money we'll bet with time. Every second will count!" +
                        "\n\nIf you lose the whole game I'll torture that long. " +
                        "\n\nLet's say I can shock you for 10 seconds in total. " +
                        "That means I will give you 10 one-second-shocks or one ten-second shock. " +
                        "Probably something in between. That's totally up to me." +
                        "\n\nIf you are very brave, we might play a little torture game. I'll explain it when you lose." +
                        "\n\nWhat also is totally up to me is how hard the shocks will be.",
                "Here are the blackjack rules:" +
                        "\nEvery round you can bet on your torture time in seconds." +
                        "\nIf you win, your final torture time will be lowered by your bet." +
                        "\nBut if you lose, your torture time goes up!" +
                        "\nTo make the game more spicy, your bet is trippled if a queen appeares on the table and I win." +
                        " We can change that and play without trippled bets, if you chicken out.",
                "Always getting same shock is boring. But my brand new electro shock device has pain levels ranging from " +
                        PAINLEVELRANGELIMIT.min() + " to " + PAINLEVELRANGELIMIT.max() + "!" +
                        String.format("\nThe lower levels just tingle a little. So we start at let's say %d.", painLevelRange.min()) +
                        "\nEvery round I'll turn the pain level one higher." +
                        " But not to the max while we play. The max levels are saved for your torture when you lose!",
                "\n\nIf you get busted, you will be punished with this penalties:\n" +
                        bustText,
                "\nIf you fold, I'll torture you for the time of your betted seconds. " +
                        "The pain level will be equal to the value of your cards." +
                        "\nYou may fold early to avoid losing a hand, but you'll still earn half the time bet!" +
                        "\n\nA Blackjack will double the time bet!" +
                        "\n\nYou can double your time bet, but you'll only get one card!"
        ]
        rulesTexts.each { text ->
            show(text)
            showButton("Ok")
        }
    }

    def showInfo = {
        show("\n\n'Shock Blackjack' and 'Shock Yourself' must be installed")
        showButton("Back")
    }

//    setImage(SHOCKBLACKJACK_DIR + dealerNameLower + "_intro.jpg")
    showDealer()
    def introText = "<span style='font-size: xx-large';')>ShockJack</span>" +
            "\n\nHi! I'm " + dealerName + "!\n\nYou wanna see me naked? Let's play strip blackjack!" +
            "\n\nBut if you lose, I'll torture you!"

    while (!getBoolean(introText, "Let's Play", "Info")) {
        showInfo()
    }

    int menu = getSelectedValue("Do you know the rules?", [
            "Yes",
            "No",
            "Change Rules"
    ])
    switch (menu) {
        case 0:
            playGame()
            break
        case 1:
            showRules()
            break
        case 2:
            changeConfig()
            break
    }
}


def playUnfinishedPunishment = {
    if (!unfinishedPunishment) return

    finalShockTime = loadInteger("ShockJack.finalShockTime")
    if (finalShockTime != null && finalShockTime > 0) {
        String introName = loadString("intro.name")
        punishShockTime = Math.ceil(0.11 * finalShockTime) * 10
        showDealer()
        show("Do you think I forgot about your punishment, " + introName + "?")
        showButton("I'm sorry, " + dealerName)

        boolean punishNow = false
        if (finalShockTime <= 30) {
            show("It's just a few seconds. I'll not punish you now, but let's increase the time a little and " +
                    "make it a round number. Let's say " + punishShockTime + " seconds." +
                    " Than let's add it to the start amount of time for our next game.")
            punishNow = getBoolean(null, "Please punish me now, " + dealerName, "Thank you, " + dealerName)
        } else {
            show("You will be sorry! You have " + finalShockTime + " seconds of torture left!" +
                    "\nI'll increase the shock time a and make it a round number! Let's say " + punishShockTime + " seconds." +
                    "\n\nBut I'll give you a chance to avoid your punishment!" +
                    "\n\nLet's play \"Double or Nothing\"!" +
                    "\n\nSimple rules:\nYou have to win one round!\nA tie is a loss for you!" +
                    "\nNo Fold!\nNo Double!\nNo Tripple!" +
                    "\n\nIf you win, you'll get away unpunished!" +
                    "\n\nBut if you lose, I'll punish you for " + (2 * punishShockTime) + " seconds!")
            punishNow = getBoolean(null, "No, please punish me now, " + dealerName, "Let's play \"Double or Nothing\"")

            if (punishNow) {
                show("As you wish!")
            } else {
                finalShockTime = 0
                placedBet = 2 * punishShockTime
                queenTrippleBets = false
                disableFold = true
                disableDouble = true
                List outcome = playBlackJackRound()
                wait(2)
                if (outcome[0] == "WIN") {
                    show("That was just pure luck! Next time you'll get it!")
                    finalShockTime = 0
                    save("ShockJack.finalShockTime", finalShockTime)
                    showButton("Thank you, " + dealerName)
                } else {
                    show("Now you'll get it!")
                    punishNow = true
                    finalShockTime = placedBet
                }
                placedBet = 0
                queenTrippleBets = loadBoolean("ShockJack.queenTrippleBets")
                disableFold = false
                disableDouble = false
            }
        }

        if (punishNow) {
            showDealer()
            wait(2)
            playPunishment()
        }
    }
}


loadConfig()
while (true) {
    show(null)
    setImage(null)
    playBackgroundSound(null)
    dealerCloth = dealerImages.size() - 1
    playUnfinishedPunishment()
    showIntro()
}


/*
 * Resources
 * scripts/ShockJack.groovy
 */
